Bug 1064352 - Review Request: rubygem-deep_merge - Merges deep hashes in ruby.
Summary: Review Request: rubygem-deep_merge - Merges deep hashes in ruby.
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Ken Dreyer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-02-12 13:12 UTC by Steve Traylen
Modified: 2014-07-20 17:58 UTC (History)
3 users (show)

Fixed In Version: rubygem-deep_merge-1.0.1-5.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-07-04 00:27:24 UTC
ktdreyer: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Steve Traylen 2014-02-12 13:12:48 UTC
Spec URL: http://cern.ch/straylen/rubygem-deep_merge/rubygem-deep_merge.spec
SRPM URL:  http://cern.ch/straylen/rubygem-deep_merge/rubygem-deep_merge-1.0.1-1.fc20.src.rpm
Description: Merges deep hashes in ruby
Fedora Account System Username: stevetraylen

Comment 2 Ken Dreyer 2014-05-28 01:30:46 UTC
Hi Steve, I can take this one. Mind conditionalizing the Requires and Provides to follow the latest Ruby Packaging Guidelines? For example:

  %if 0%{?el6}
  Requires:      ruby(abi) = 1.8
  %endif
  %if 0%{?fc19} || 0%{?fc20} || 0%{?el7}
  Requires:      ruby(release)
  %endif

  %if 0%{?fc19} || 0%{?fc20} || 0%{?el6} || 0%{?el7}
  Provides: rubygem(%{gem_name}) = %{version}
  %endif

It also looks like upstream's test suite is not compatible with Minitest 5, so Rawhide builds fail. You can use the patch from https://github.com/danielsdeleo/deep_merge/pull/13

Comment 3 Steve Traylen 2014-05-30 12:54:25 UTC
Just noticed that PL call this package rubygem-deep-merge rather than deep_merge. The latter is correct in the Fedora guidelines sense so we stick with that.

Comment 4 Steve Traylen 2014-05-30 14:12:07 UTC
http://cern.ch/straylen/rpms/rubygem-deep_merge/rubygem-deep_merge-1.0.1-2.fc20.src.rpm

is a new package but it's still not building on rawhide.

I had to backport the minitest5 patch to this version but still
something is wrong.

Comment 5 Ken Dreyer 2014-05-30 19:57:22 UTC
The issue is that testrb invokes the test library that comes from stdlib. testrb has a couple of weird gotchas like this. (Another problem I've found is that it won't always exit with the correct exit code.)

You can remove testrb from %check and replace it with a simple ruby invocation, like so:

  ruby -Ilib test/test_deep_merge.rb

testrb is going to be removed in the next version of Ruby (https://lists.fedoraproject.org/pipermail/ruby-sig/2014-May/001585.html) so it's a good idea to remove it.

Comment 6 Steve Traylen 2014-06-02 08:01:44 UTC
Thanks for the pointer:

http://cern.ch/straylen/rpms/rubygem-deep_merge/rubygem-deep_merge-1.0.1-3.fc20.src.rpm

Comment 7 Ken Dreyer 2014-06-02 23:46:03 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package must contain a full copy of the MIT license.  The good news is that
  upstream has a LICENSE file in Git. The bad news is that they are not
  shipping the file in the gem from rubygems.org. I've filed an issue for this
  at https://github.com/danielsdeleo/deep_merge/pull/14, and in the mean time,
  you can add a SOURCE1 pointing to
  https://raw.githubusercontent.com/danielsdeleo/deep_merge/master/LICENSE
  and ship the file in the main rubygem-deep_merge package.

- This is a minor thing that doesn't block approval: the "URL" field can be
  updated to use HTTPS for github.com. (Reported upstream at
  https://github.com/danielsdeleo/deep_merge/pull/15).

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
[!]: License file installed when any subpackage combination is installed.
     See issue listed above.
[x]: Package must own all directories that it creates.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch
[x]: Package does not contain Requires: ruby(abi).
[x]: Package contains Requires: ruby(release).

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Avoid bundling fonts in non-fonts packages.
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[x]: Gem should use %gem_install macro.
[x]: Specfile should use macros from rubygem-devel package.
[x]: Gem package should exclude cached Gem.
[x]: Test suite should not be run by rake.
[x]: Test suite of the library should be run.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: rubygem-deep_merge-1.0.1-3.fc21.noarch.rpm
          rubygem-deep_merge-doc-1.0.1-3.fc21.noarch.rpm
          rubygem-deep_merge-1.0.1-3.fc21.src.rpm
rubygem-deep_merge.noarch: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-deep_merge-doc rubygem-deep_merge
rubygem-deep_merge.noarch: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
rubygem-deep_merge-doc (rpmlib, GLIBC filtered):
    rubygem-deep_merge

rubygem-deep_merge (rpmlib, GLIBC filtered):
    ruby(rubygems)



Provides
--------
rubygem-deep_merge-doc:
    rubygem-deep_merge-doc

rubygem-deep_merge:
    rubygem(deep_merge)
    rubygem-deep_merge



Source checksums
----------------
https://rubygems.org/gems/deep_merge-1.0.1.gem :
  CHECKSUM(SHA256) this package     : 2dcc68cc5af7b3d336fd528ec2c54f7790a72b832c8c6689e9c907d0e764718c
  CHECKSUM(SHA256) upstream package : 2dcc68cc5af7b3d336fd528ec2c54f7790a72b832c8c6689e9c907d0e764718c


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1064352 -m fedora-rawhide-x86_64 --rpm-spec
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Ruby, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 8 Steve Traylen 2014-06-03 08:15:31 UTC
Thanks again, all recommendations applied:


http://cern.ch/straylen/rpms/rubygem-deep_merge/rubygem-deep_merge-1.0.1-4.fc20.src.rpm

I really must review some packages if you have any else I'll find some.

Comment 9 Ken Dreyer 2014-06-03 13:27:01 UTC
All issues addressed, APPROVED :)

Mind swapping for this one? https://bugzilla.redhat.com/show_bug.cgi?id=1047070

Comment 10 Steve Traylen 2014-06-16 08:16:57 UTC
New Package SCM Request
=======================
Package Name: rubygem-deep_merge
Short Description:  Merges deep hashes in ruby.
Upstream URL: https://github.com/danielsdeleo/deep_merge
Owners: stevetraylen
Branches:f20 el6 epel7
InitialCC:

Comment 11 Kevin Fenzi 2014-06-18 16:11:38 UTC
Git done (by process-git-requests).

Comment 12 Fedora Update System 2014-06-19 09:39:58 UTC
rubygem-deep_merge-1.0.1-5.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/rubygem-deep_merge-1.0.1-5.el6

Comment 13 Fedora Update System 2014-06-19 09:40:09 UTC
rubygem-deep_merge-1.0.1-5.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/rubygem-deep_merge-1.0.1-5.fc20

Comment 14 Fedora Update System 2014-06-19 16:36:56 UTC
rubygem-deep_merge-1.0.1-5.el6 has been pushed to the Fedora EPEL 6 testing repository.

Comment 15 Fedora Update System 2014-07-04 00:27:24 UTC
rubygem-deep_merge-1.0.1-5.fc20 has been pushed to the Fedora 20 stable repository.

Comment 16 Fedora Update System 2014-07-20 17:58:11 UTC
rubygem-deep_merge-1.0.1-5.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.